Bug 2000976 - Review Request: pdftk-java - GCJ-free toolkit for manipulating PDF documents
Summary: Review Request: pdftk-java - GCJ-free toolkit for manipulating PDF documents
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Didik Supriadi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-09-03 13:18 UTC by Robert Scheck
Modified: 2021-10-29 23:09 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-10-28 18:50:22 UTC
Type: Bug
didiksupriadi41: fedora-review+


Attachments (Terms of Use)

Description Robert Scheck 2021-09-03 13:18:26 UTC
Spec URL: https://labs.linuxnetz.de/bugzilla/pdftk-java.spec
SRPM URL: https://labs.linuxnetz.de/bugzilla/pdftk-java-3.3.1-1.src.rpm
Description: If PDF is electronic paper, then pdftk-java is an electronic staple-remover, hole-punch, binder, secret-decoder-ring, and X-Ray-glasses. PDFtk is a simple tool for doing everyday things with PDF documents: Merge PDF documents, split PDF pages into a new document, decrypt input as necessary (password required), encrypt output as desired, burst a PDF document into single pages, report on PDF metrics, including metadata and bookmarks, uncompress and re-compress page streams, and repair corrupted PDF (where possible).

Pdftk-java is a port of the original GCJ-based PDFtk to Java. The GNU Compiler for Java (GCJ) is a portable, optimizing, ahead-of-time compiler for the Java programming language, which had no new developments since 2009 and was finally removed in 2016 from the GCC development tree before the release of GCC 7.
Fedora Account System Username: robert

Notes:
- I used pdftk-java as package name to clearly distinct from the (GCJ-based) pdftk, but if a reviewer insists on pdftk, this can be changed. As of writing Debian/Ubuntu and Mageia use pdftk-java and Gentoo and Arch/Manjaro use pdftk as package name.
- The Fedora Java packaging howto doesn't seem to be in a good shape, because https://docs.fedoraproject.org/en-US/java-packaging-howto/gradle/ suggests "BuildRequires: gradle-local" while Rawhide mock build says "No matching package to install: 'gradle-local'", thus I simply used plain ant.

Comment 1 Didik Supriadi 2021-09-16 19:22:41 UTC
Hi,

(In reply to Robert Scheck from comment #0)
> Notes:
> ...
> - The Fedora Java packaging howto doesn't seem to be in a good shape,
> because https://docs.fedoraproject.org/en-US/java-packaging-howto/gradle/
> suggests "BuildRequires: gradle-local" while Rawhide mock build says "No
> matching package to install: 'gradle-local'", thus I simply used plain ant.

What about using maven build?
I just added the (maven) pom file upstream [1], but it depends on one of my
package review [2]. Would you like a review swap?

[1] https://gitlab.com/pdftk-java/pdftk/-/commit/dff7a046470577b3834116b2ef3b401e1a65bada.patch
[2] https://bugzilla.redhat.com/show_bug.cgi?id=1999177

Comment 2 Robert Scheck 2021-09-27 23:29:27 UTC
I'm not really sure what a good answer would be: I'm not experienced in Java packaging, so I wonder which benefits Maven adds here.

Comment 3 Didik Supriadi 2021-09-28 04:52:30 UTC
(In reply to Robert Scheck from comment #2)
> I'm not really sure what a good answer would be: I'm not experienced in Java packaging

Well, it doesn't matter. It's your choice. I need someone who would like to know or rather knows maven to take my package review.
I'd take this as my list of reviews, nonetheless.

> so I wonder which benefits Maven adds here.

because:
1) auto-requires and auto-provides just works so you only need BRs in maven.
2) you don't need %check and use maven tests instead. (or use both)

Comment 4 Didik Supriadi 2021-10-19 13:48:12 UTC
This package is APPROVED

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU General Public License, Version
     2", "*No copyright* [generated file]", "*No copyright* GNU General
     Public License v2.0 or later", "*No copyright* Apache License 2.0",
     "GNU Lesser General Public License, Version 2.1", "GNU Library General
     Public License, Version 2.0", "MIT License", "*No copyright* GNU
     General Public License v2.0 or later [obsolete FSF postal address
     (Temple Place)]", "*No copyright* Public domain", "*No copyright* GNU
     Library General Public License v2 or later", "*No copyright* GNU
     General Public License v3.0 or later", "*No copyright* GNU General
     Public License", "zlib/libpng license", "SIL Open Font License 1.1",
     "GNU General Public License v2.0 or later", "*No copyright* Mozilla
     Public License 1.1 GNU Library General Public License v2 or later",
     "GNU Library General Public License v2 or later", "*No copyright* GNU
     Lesser General Public License, Version 2.1 Apache License 2.0", "Adobe
     Postscript AFM License". 86 files have unknown license. Detailed
     output of licensecheck in /home/dsupriadi/2000976-pdftk-
     java/licensecheck.txt
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: pdftk-java-3.3.1-1.fc36.noarch.rpm
          pdftk-java-3.3.1-1.fc36.src.rpm
pdftk-java.noarch: W: spelling-error %description -l en_US decrypt -> decry pt, decry-pt, decry
pdftk-java.noarch: W: spelling-error %description -l en_US uncompress -> uncompressed, compression, compressor
pdftk-java.src: W: spelling-error %description -l en_US decrypt -> decry pt, decry-pt, decry
pdftk-java.src: W: spelling-error %description -l en_US uncompress -> uncompressed, compression, compressor
2 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 5 Gwyn Ciesla 2021-10-19 15:15:38 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/pdftk-java

Comment 6 Robert Scheck 2021-10-19 20:38:09 UTC
First of all, thank you very much for the review!


(In reply to Didik Supriadi from comment #3)
> Well, it doesn't matter. It's your choice. I need someone who would like to
> know or rather knows maven to take my package review.

My only connection to Java is this package, because there is unfortunately no Java-free alternative/replacement. I've noticed that you're on the IRC as well...maybe we can continue there to finally make this some kind of review swapping, even I fear that I have to ask for the sense/background of most %pom_* macro activities.

Comment 7 Fedora Update System 2021-10-19 20:40:03 UTC
FEDORA-EPEL-2021-046c1b40cb has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-046c1b40cb

Comment 8 Fedora Update System 2021-10-19 20:40:04 UTC
FEDORA-2021-5b239955d2 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-5b239955d2

Comment 9 Fedora Update System 2021-10-19 20:40:04 UTC
FEDORA-EPEL-2021-18bad03d1d has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-18bad03d1d

Comment 10 Fedora Update System 2021-10-20 18:41:55 UTC
FEDORA-EPEL-2021-046c1b40cb has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-046c1b40cb

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2021-10-20 19:29:32 UTC
FEDORA-2021-5b239955d2 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-5b239955d2 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-5b239955d2

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-10-20 19:42:52 UTC
FEDORA-EPEL-2021-18bad03d1d has been pushed to the Fedora EPEL 7 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-18bad03d1d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2021-10-20 20:03:18 UTC
FEDORA-2021-ac7cbdaa46 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-ac7cbdaa46 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-ac7cbdaa46

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2021-10-21 02:21:25 UTC
FEDORA-2021-716903eb5e has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-716903eb5e \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-716903eb5e

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2021-10-28 18:50:22 UTC
FEDORA-EPEL-2021-046c1b40cb has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2021-10-28 19:30:55 UTC
FEDORA-2021-ac7cbdaa46 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2021-10-28 19:30:57 UTC
FEDORA-2021-5b239955d2 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 18 Fedora Update System 2021-10-28 19:55:24 UTC
FEDORA-EPEL-2021-18bad03d1d has been pushed to the Fedora EPEL 7 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 19 Fedora Update System 2021-10-29 23:09:25 UTC
FEDORA-2021-716903eb5e has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.